/* Switchboard.c generated by valac 0.54.6, the Vala compiler
 * generated from Switchboard.vala, do not modify */

/*
* Copyright (c) 2011-2017 elementary LLC (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA.
*
* Authored by: Avi Romanoff <avi@romanoff.me>
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <clutter-gtk/clutter-gtk.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <gee.h>
#include "switchboard.h"
#include <granite.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <gio/gdesktopappinfo.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	SWITCHBOARD_WINDOW_STATE_NORMAL = 0,
	SWITCHBOARD_WINDOW_STATE_MAXIMIZED = 1
} SwitchboardWindowState;

#define SWITCHBOARD_TYPE_WINDOW_STATE (switchboard_window_state_get_type ())

#define SWITCHBOARD_TYPE_SWITCHBOARD_APP (switchboard_switchboard_app_get_type ())
#define SWITCHBOARD_SWITCHBOARD_APP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SWITCHBOARD_TYPE_SWITCHBOARD_APP, SwitchboardSwitchboardApp))
#define SWITCHBOARD_SWITCHBOARD_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SWITCHBOARD_TYPE_SWITCHBOARD_APP, SwitchboardSwitchboardAppClass))
#define SWITCHBOARD_IS_SWITCHBOARD_APP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SWITCHBOARD_TYPE_SWITCHBOARD_APP))
#define SWITCHBOARD_IS_SWITCHBOARD_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SWITCHBOARD_TYPE_SWITCHBOARD_APP))
#define SWITCHBOARD_SWITCHBOARD_APP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SWITCHBOARD_TYPE_SWITCHBOARD_APP, SwitchboardSwitchboardAppClass))

typedef struct _SwitchboardSwitchboardApp SwitchboardSwitchboardApp;
typedef struct _SwitchboardSwitchboardAppClass SwitchboardSwitchboardAppClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _SwitchboardSwitchboardAppPrivate SwitchboardSwitchboardAppPrivate;

#define SWITCHBOARD_TYPE_CATEGORY_VIEW (switchboard_category_view_get_type ())
#define SWITCHBOARD_CATEGORY_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SWITCHBOARD_TYPE_CATEGORY_VIEW, SwitchboardCategoryView))
#define SWITCHBOARD_CATEGORY_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SWITCHBOARD_TYPE_CATEGORY_VIEW, SwitchboardCategoryViewClass))
#define SWITCHBOARD_IS_CATEGORY_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SWITCHBOARD_TYPE_CATEGORY_VIEW))
#define SWITCHBOARD_IS_CATEGORY_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SWITCHBOARD_TYPE_CATEGORY_VIEW))
#define SWITCHBOARD_CATEGORY_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SWITCHBOARD_TYPE_CATEGORY_VIEW, SwitchboardCategoryViewClass))

typedef struct _SwitchboardCategoryView SwitchboardCategoryView;
typedef struct _SwitchboardCategoryViewClass SwitchboardCategoryViewClass;
enum  {
	SWITCHBOARD_SWITCHBOARD_APP_0_PROPERTY,
	SWITCHBOARD_SWITCHBOARD_APP_SEARCH_BOX_PROPERTY,
	SWITCHBOARD_SWITCHBOARD_APP_NUM_PROPERTIES
};
static GParamSpec* switchboard_switchboard_app_properties[SWITCHBOARD_SWITCHBOARD_APP_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _Block1Data Block1Data;

#define SWITCHBOARD_TYPE_SEARCH_ENTRY (switchboard_search_entry_get_type ())
typedef struct _SwitchboardSearchEntry SwitchboardSearchEntry;
#define _switchboard_search_entry_free0(var) ((var == NULL) ? NULL : (var = (switchboard_search_entry_free (var), NULL)))
typedef struct _Block2Data Block2Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _SwitchboardSwitchboardApp {
	GtkApplication parent_instance;
	SwitchboardSwitchboardAppPrivate * priv;
	SwitchboardCategoryView* category_view;
	GeeArrayList* previous_plugs;
	SwitchboardPlug* current_plug;
};

struct _SwitchboardSwitchboardAppClass {
	GtkApplicationClass parent_class;
};

struct _SwitchboardSwitchboardAppPrivate {
	GtkWindow* main_window;
	GtkScrolledWindow* category_scrolled;
	GtkStack* stack;
	GtkHeaderBar* headerbar;
	GraniteWidgetsAlertView* alert_view;
	GtkButton* navigation_button;
	GeeLinkedList* loaded_plugs;
	gchar* all_settings_label;
	GtkSearchEntry* _search_box;
};

struct _Block1Data {
	int _ref_count_;
	SwitchboardSwitchboardApp* self;
	SwitchboardPlug* plug;
};

struct _SwitchboardSearchEntry {
	gchar* plug_name;
	gchar* ui_elements;
	gchar* open_window;
};

struct _Block2Data {
	int _ref_count_;
	SwitchboardSwitchboardApp* self;
	GSettings* settings;
};

static gint SwitchboardSwitchboardApp_private_offset;
static gpointer switchboard_switchboard_app_parent_class = NULL;
static gchar* switchboard_switchboard_app_plug_to_open;
static gchar* switchboard_switchboard_app_plug_to_open = NULL;
static gchar* switchboard_switchboard_app_open_window;
static gchar* switchboard_switchboard_app_open_window = NULL;
static gchar* switchboard_switchboard_app_link;
static gchar* switchboard_switchboard_app_link = NULL;
static gboolean switchboard_switchboard_app_opened_directly;
static gboolean switchboard_switchboard_app_opened_directly = FALSE;
static gboolean switchboard_switchboard_app_should_animate_next_transition;
static gboolean switchboard_switchboard_app_should_animate_next_transition = TRUE;
static SwitchboardSwitchboardApp* switchboard_switchboard_app__instance;
static SwitchboardSwitchboardApp* switchboard_switchboard_app__instance = NULL;

VALA_EXTERN GType switchboard_window_state_get_type (void) G_GNUC_CONST ;
static gint switchboard_main (gchar** args,
                       gint args_length1);
VALA_EXTERN GType switchboard_switchboard_app_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SwitchboardSwitchboardApp, g_object_unref)
VALA_EXTERN SwitchboardSwitchboardApp* switchboard_switchboard_app_get_instance (void);
VALA_EXTERN GType switchboard_category_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SwitchboardCategoryView, g_object_unref)
static void switchboard_switchboard_app_real_open (GApplication* base,
                                            GFile** files,
                                            gint files_length1,
                                            const gchar* hint);
static gchar* switchboard_switchboard_app_gcc_to_switchboard_code_name (SwitchboardSwitchboardApp* self,
                                                                 const gchar* gcc_name);
static void switchboard_switchboard_app_real_activate (GApplication* base);
static gboolean switchboard_switchboard_app_load_setting_path (SwitchboardSwitchboardApp* self,
                                                        const gchar* setting_path,
                                                        SwitchboardPlugsManager* plugsmanager);
VALA_EXTERN void switchboard_switchboard_app_load_plug (SwitchboardSwitchboardApp* self,
                                            SwitchboardPlug* plug);
static void switchboard_switchboard_app_build (SwitchboardSwitchboardApp* self);
VALA_EXTERN void switchboard_switchboard_app_hide_alert (SwitchboardSwitchboardApp* self);
VALA_EXTERN void switchboard_switchboard_app_show_alert (SwitchboardSwitchboardApp* self,
                                             const gchar* primary_text,
                                             const gchar* secondary_text,
                                             const gchar* icon_name);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean __lambda6_ (Block1Data* _data1_);
VALA_EXTERN GType switchboard_search_entry_get_type (void) G_GNUC_CONST ;
VALA_EXTERN SwitchboardSearchEntry* switchboard_search_entry_dup (const SwitchboardSearchEntry* self);
VALA_EXTERN void switchboard_search_entry_free (SwitchboardSearchEntry* self);
VALA_EXTERN void switchboard_search_entry_copy (const SwitchboardSearchEntry* self,
                                    SwitchboardSearchEntry* dest);
VALA_EXTERN void switchboard_search_entry_destroy (SwitchboardSearchEntry* self);
VALA_EXTERN GeeArrayList* switchboard_category_view_get_plug_search_result (SwitchboardCategoryView* self);
static gboolean __lambda7_ (Block1Data* _data1_,
                     SwitchboardSearchEntry* entry);
static gboolean ___lambda7__gee_forall_func (gpointer g,
                                      gpointer self);
static void switchboard_switchboard_app_switch_to_plug (SwitchboardSwitchboardApp* self,
                                                 SwitchboardPlug* plug);
static gboolean ___lambda6__gsource_func (gpointer self);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void switchboard_switchboard_app_set_search_box (SwitchboardSwitchboardApp* self,
                                                 GtkSearchEntry* value);
VALA_EXTERN GtkSearchEntry* switchboard_switchboard_app_get_search_box (SwitchboardSwitchboardApp* self);
VALA_EXTERN SwitchboardCategoryView* switchboard_category_view_new (const gchar* plug);
VALA_EXTERN SwitchboardCategoryView* switchboard_category_view_construct (GType object_type,
                                                              const gchar* plug);
static void __lambda12_ (SwitchboardSwitchboardApp* self,
                  SwitchboardPlug* plug);
static void ___lambda12__switchboard_category_view_plug_selected (SwitchboardCategoryView* _sender,
                                                           SwitchboardPlug* plug,
                                                           gpointer self);
VALA_EXTERN void switchboard_category_view_load_default_plugs (SwitchboardCategoryView* self,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
VALA_EXTERN void switchboard_category_view_load_default_plugs_finish (SwitchboardCategoryView* self,
                                                          GAsyncResult* _res_);
static void switchboard_switchboard_app_handle_navigation_button_clicked (SwitchboardSwitchboardApp* self);
static void _switchboard_switchboard_app_handle_navigation_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                                       gpointer self);
static void __lambda13_ (SwitchboardSwitchboardApp* self);
VALA_EXTERN void switchboard_category_view_filter_plugs (SwitchboardCategoryView* self,
                                             const gchar* filter);
static void ___lambda13__gtk_editable_changed (GtkEditable* _sender,
                                        gpointer self);
static gboolean __lambda14_ (SwitchboardSwitchboardApp* self,
                      GdkEventKey* event);
VALA_EXTERN void switchboard_category_view_activate_first_item (SwitchboardCategoryView* self);
static gboolean ___lambda14__gtk_widget_key_press_event (GtkWidget* _sender,
                                                  GdkEventKey* event,
                                                  gpointer self);
static void __lambda15_ (SwitchboardSwitchboardApp* self);
static void ___lambda15__g_simple_action_activate (GSimpleAction* _sender,
                                            GVariant* parameter,
                                            gpointer self);
static void __lambda16_ (SwitchboardSwitchboardApp* self);
static void ___lambda16__g_simple_action_activate (GSimpleAction* _sender,
                                            GVariant* parameter,
                                            gpointer self);
static gboolean __lambda17_ (SwitchboardSwitchboardApp* self,
                      GdkEventButton* event);
static gboolean ___lambda17__gtk_widget_button_release_event (GtkWidget* _sender,
                                                       GdkEventButton* event,
                                                       gpointer self);
static void switchboard_switchboard_app_shut_down (SwitchboardSwitchboardApp* self);
static void _switchboard_switchboard_app_shut_down_gtk_widget_destroy (GtkWidget* _sender,
                                                                gpointer self);
static gboolean __lambda18_ (Block2Data* _data2_);
static gboolean ___lambda18__gtk_widget_delete_event (GtkWidget* _sender,
                                               GdkEventAny* event,
                                               gpointer self);
static gboolean __lambda19_ (SwitchboardSwitchboardApp* self,
                      GdkEventKey* event);
VALA_EXTERN void switchboard_category_view_grab_focus_first_icon_view (SwitchboardCategoryView* self);
static gboolean _vala_uint_array_contains (guint * stack,
                                    gssize stack_length,
                                    const guint needle);
static gboolean ___lambda19__gtk_widget_key_press_event (GtkWidget* _sender,
                                                  GdkEventKey* event,
                                                  gpointer self);
static gboolean __lambda20_ (Block2Data* _data2_,
                      GdkEventWindowState* event);
static gboolean ___lambda20__gtk_widget_window_state_event (GtkWidget* _sender,
                                                     GdkEventWindowState* event,
                                                     gpointer self);
static void __lambda21_ (SwitchboardSwitchboardApp* self);
static void ___lambda21__gtk_widget_size_allocate (GtkWidget* _sender,
                                            GtkAllocation* allocation,
                                            gpointer self);
static gboolean switchboard_switchboard_app_switch_to_icons (SwitchboardSwitchboardApp* self);
VALA_EXTERN SwitchboardSwitchboardApp* switchboard_switchboard_app_new (void);
VALA_EXTERN SwitchboardSwitchboardApp* switchboard_switchboard_app_construct (GType object_type);
static GObject * switchboard_switchboard_app_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties);
static void switchboard_switchboard_app_finalize (GObject * obj);
static GType switchboard_switchboard_app_get_type_once (void);
static void _vala_switchboard_switchboard_app_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_switchboard_switchboard_app_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static const guint SWITCHBOARD_SWITCHBOARD_APP_NAVIGATION_KEYS[5] = {GDK_KEY_Up, GDK_KEY_Down, GDK_KEY_Left, GDK_KEY_Right, GDK_KEY_Return};

static GType
switchboard_window_state_get_type_once (void)
{
	static const GEnumValue values[] = {{SWITCHBOARD_WINDOW_STATE_NORMAL, "SWITCHBOARD_WINDOW_STATE_NORMAL", "normal"}, {SWITCHBOARD_WINDOW_STATE_MAXIMIZED, "SWITCHBOARD_WINDOW_STATE_MAXIMIZED", "maximized"}, {0, NULL, NULL}};
	GType switchboard_window_state_type_id;
	switchboard_window_state_type_id = g_enum_register_static ("SwitchboardWindowState", values);
	return switchboard_window_state_type_id;
}

GType
switchboard_window_state_get_type (void)
{
	static volatile gsize switchboard_window_state_type_id__volatile = 0;
	if (g_once_init_enter (&switchboard_window_state_type_id__volatile)) {
		GType switchboard_window_state_type_id;
		switchboard_window_state_type_id = switchboard_window_state_get_type_once ();
		g_once_init_leave (&switchboard_window_state_type_id__volatile, switchboard_window_state_type_id);
	}
	return switchboard_window_state_type_id__volatile;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gint
switchboard_main (gchar** args,
                  gint args_length1)
{
	SwitchboardSwitchboardApp* app = NULL;
	SwitchboardSwitchboardApp* _tmp0_;
	SwitchboardSwitchboardApp* _tmp1_;
	SwitchboardSwitchboardApp* _tmp2_;
	gint result = 0;
	gtk_clutter_init ((gint*) (&args_length1), &args);
	_tmp0_ = switchboard_switchboard_app_get_instance ();
	_tmp1_ = _tmp0_;
	_tmp2_ = _g_object_ref0 (_tmp1_);
	app = _tmp2_;
	result = g_application_run ((GApplication*) app, (gint) args_length1, args);
	_g_object_unref0 (app);
	return result;
}

int
main (int argc,
      char ** argv)
{
	return switchboard_main (argv, argc);
}

static inline gpointer
switchboard_switchboard_app_get_instance_private (SwitchboardSwitchboardApp* self)
{
	return G_STRUCT_MEMBER_P (self, SwitchboardSwitchboardApp_private_offset);
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result = 0L;
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
	end = _tmp0_;
	_tmp1_ = end;
	if (_tmp1_ == NULL) {
		result = maxlen;
		return result;
	} else {
		gchar* _tmp2_;
		_tmp2_ = end;
		result = (glong) (_tmp2_ - str);
		return result;
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	if (offset >= ((glong) 0)) {
		_tmp0_ = len >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		string_length = string_strnlen ((gchar*) self, offset + len);
	} else {
		gint _tmp1_;
		gint _tmp2_;
		_tmp1_ = strlen (self);
		_tmp2_ = _tmp1_;
		string_length = (glong) _tmp2_;
	}
	if (offset < ((glong) 0)) {
		offset = string_length + offset;
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
	} else {
		g_return_val_if_fail (offset <= string_length, NULL);
	}
	if (len < ((glong) 0)) {
		len = string_length - offset;
	}
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
	result = _tmp3_;
	return result;
}

static gint
string_last_index_of_char (const gchar* self,
                           gunichar c,
                           gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = g_utf8_strrchr (((gchar*) self) + start_index, (gssize) -1, c);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	if (_tmp1_ != NULL) {
		gchar* _tmp2_;
		_tmp2_ = _result_;
		result = (gint) (_tmp2_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static void
switchboard_switchboard_app_real_open (GApplication* base,
                                       GFile** files,
                                       gint files_length1,
                                       const gchar* hint)
{
	SwitchboardSwitchboardApp * self;
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gboolean _tmp6_;
	self = (SwitchboardSwitchboardApp*) base;
	g_return_if_fail (hint != NULL);
	_tmp0_ = files[0];
	_tmp1_ = _g_object_ref0 (_tmp0_);
	file = _tmp1_;
	_tmp2_ = file;
	if (_tmp2_ == NULL) {
		_g_object_unref0 (file);
		return;
	}
	_tmp3_ = file;
	_tmp4_ = g_file_get_uri_scheme (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_strcmp0 (_tmp5_, "settings") == 0;
	_g_free0 (_tmp5_);
	if (_tmp6_) {
		GFile* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		const gchar* _tmp11_;
		_tmp7_ = file;
		_tmp8_ = g_file_get_uri (_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp10_ = string_replace (_tmp9_, "settings://", "");
		_g_free0 (switchboard_switchboard_app_link);
		switchboard_switchboard_app_link = _tmp10_;
		_g_free0 (_tmp9_);
		_tmp11_ = switchboard_switchboard_app_link;
		if (g_str_has_suffix (_tmp11_, "/")) {
			const gchar* _tmp12_;
			const gchar* _tmp13_;
			gchar* _tmp14_;
			_tmp12_ = switchboard_switchboard_app_link;
			_tmp13_ = switchboard_switchboard_app_link;
			_tmp14_ = string_substring (_tmp12_, (glong) 0, (glong) string_last_index_of_char (_tmp13_, (gunichar) '/', 0));
			_g_free0 (switchboard_switchboard_app_link);
			switchboard_switchboard_app_link = _tmp14_;
		}
	} else {
		gchar* name = NULL;
		GFile* _tmp15_;
		gchar* _tmp16_;
		const gchar* _tmp17_;
		g_warning ("Switchboard.vala:105: Calling Switchboard directly is deprecated, plea" \
"se use the settings:// scheme instead");
		_tmp15_ = file;
		_tmp16_ = g_file_get_basename (_tmp15_);
		name = _tmp16_;
		_tmp17_ = name;
		if (string_contains (_tmp17_, ":")) {
			gchar** parts = NULL;
			const gchar* _tmp18_;
			gchar** _tmp19_;
			gchar** _tmp20_;
			gint parts_length1;
			gint _parts_size_;
			gchar** _tmp21_;
			gint _tmp21__length1;
			const gchar* _tmp22_;
			gchar* _tmp23_;
			gchar** _tmp24_;
			gint _tmp24__length1;
			const gchar* _tmp25_;
			gchar* _tmp26_;
			_tmp18_ = name;
			_tmp20_ = _tmp19_ = g_strsplit (_tmp18_, ":", 0);
			parts = _tmp20_;
			parts_length1 = _vala_array_length (_tmp19_);
			_parts_size_ = parts_length1;
			_tmp21_ = parts;
			_tmp21__length1 = parts_length1;
			_tmp22_ = _tmp21_[0];
			_tmp23_ = switchboard_switchboard_app_gcc_to_switchboard_code_name (self, _tmp22_);
			_g_free0 (switchboard_switchboard_app_plug_to_open);
			switchboard_switchboard_app_plug_to_open = _tmp23_;
			_tmp24_ = parts;
			_tmp24__length1 = parts_length1;
			_tmp25_ = _tmp24_[1];
			_tmp26_ = g_strdup (_tmp25_);
			_g_free0 (switchboard_switchboard_app_open_window);
			switchboard_switchboard_app_open_window = _tmp26_;
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
		} else {
			const gchar* _tmp27_;
			gchar* _tmp28_;
			_tmp27_ = name;
			_tmp28_ = switchboard_switchboard_app_gcc_to_switchboard_code_name (self, _tmp27_);
			_g_free0 (switchboard_switchboard_app_plug_to_open);
			switchboard_switchboard_app_plug_to_open = _tmp28_;
		}
		_g_free0 (name);
	}
	g_application_activate ((GApplication*) self);
	_g_object_unref0 (file);
}

static void
switchboard_switchboard_app_real_activate (GApplication* base)
{
	SwitchboardSwitchboardApp * self;
	SwitchboardPlugsManager* plugsmanager = NULL;
	SwitchboardPlugsManager* _tmp0_;
	GSettings* setting = NULL;
	GSettings* _tmp1_;
	GVariant* mapping_dic = NULL;
	GSettings* _tmp2_;
	GVariant* _tmp3_;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
	GList* _tmp28_;
	GeeLinkedList* _tmp31_;
	GeeArrayList* _tmp32_;
	self = (SwitchboardSwitchboardApp*) base;
	_tmp0_ = switchboard_plugs_manager_get_default ();
	plugsmanager = _tmp0_;
	_tmp1_ = g_settings_new ("io.elementary.switchboard.preferences");
	setting = _tmp1_;
	_tmp2_ = setting;
	_tmp3_ = g_settings_get_value (_tmp2_, "mapping-override");
	mapping_dic = _tmp3_;
	_tmp5_ = switchboard_switchboard_app_link;
	if (_tmp5_ != NULL) {
		GVariant* _tmp6_;
		const gchar* _tmp7_;
		gboolean _tmp8_;
		_tmp6_ = mapping_dic;
		_tmp7_ = switchboard_switchboard_app_link;
		_tmp8_ = g_variant_lookup (_tmp6_, _tmp7_, "(ss)", &switchboard_switchboard_app_plug_to_open, &switchboard_switchboard_app_open_window, NULL);
		_tmp4_ = !_tmp8_;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		gboolean plug_found = FALSE;
		const gchar* _tmp9_;
		SwitchboardPlugsManager* _tmp10_;
		_tmp9_ = switchboard_switchboard_app_link;
		_tmp10_ = plugsmanager;
		plug_found = switchboard_switchboard_app_load_setting_path (self, _tmp9_, _tmp10_);
		if (plug_found) {
			_g_free0 (switchboard_switchboard_app_link);
			switchboard_switchboard_app_link = NULL;
			switchboard_switchboard_app_should_animate_next_transition = FALSE;
			switchboard_switchboard_app_opened_directly = TRUE;
		} else {
			const gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			_tmp11_ = switchboard_switchboard_app_link;
			_tmp12_ = g_strdup_printf (_ ("Specified link '%s' does not exist, going back to the main panel"), _tmp11_);
			_tmp13_ = _tmp12_;
			g_warning ("Switchboard.vala:133: %s", _tmp13_);
			_g_free0 (_tmp13_);
		}
	} else {
		const gchar* _tmp14_;
		_tmp14_ = switchboard_switchboard_app_plug_to_open;
		if (_tmp14_ != NULL) {
			{
				GeeIterator* _plug_it = NULL;
				SwitchboardPlugsManager* _tmp15_;
				GeeCollection* _tmp16_;
				GeeCollection* _tmp17_;
				GeeIterator* _tmp18_;
				GeeIterator* _tmp19_;
				_tmp15_ = plugsmanager;
				_tmp16_ = switchboard_plugs_manager_get_plugs (_tmp15_);
				_tmp17_ = _tmp16_;
				_tmp18_ = gee_iterable_iterator ((GeeIterable*) _tmp17_);
				_tmp19_ = _tmp18_;
				_g_object_unref0 (_tmp17_);
				_plug_it = _tmp19_;
				while (TRUE) {
					GeeIterator* _tmp20_;
					SwitchboardPlug* plug = NULL;
					GeeIterator* _tmp21_;
					gpointer _tmp22_;
					const gchar* _tmp23_;
					SwitchboardPlug* _tmp24_;
					const gchar* _tmp25_;
					const gchar* _tmp26_;
					_tmp20_ = _plug_it;
					if (!gee_iterator_next (_tmp20_)) {
						break;
					}
					_tmp21_ = _plug_it;
					_tmp22_ = gee_iterator_get (_tmp21_);
					plug = (SwitchboardPlug*) _tmp22_;
					_tmp23_ = switchboard_switchboard_app_plug_to_open;
					_tmp24_ = plug;
					_tmp25_ = switchboard_plug_get_code_name (_tmp24_);
					_tmp26_ = _tmp25_;
					if (g_str_has_suffix (_tmp23_, _tmp26_)) {
						SwitchboardPlug* _tmp27_;
						_tmp27_ = plug;
						switchboard_switchboard_app_load_plug (self, _tmp27_);
						_g_free0 (switchboard_switchboard_app_plug_to_open);
						switchboard_switchboard_app_plug_to_open = NULL;
						switchboard_switchboard_app_should_animate_next_transition = FALSE;
						switchboard_switchboard_app_opened_directly = TRUE;
						_g_object_unref0 (plug);
						break;
					}
					_g_object_unref0 (plug);
				}
				_g_object_unref0 (_plug_it);
			}
		}
	}
	_tmp28_ = gtk_application_get_windows ((GtkApplication*) self);
	if (g_list_length (_tmp28_) > ((guint) 0)) {
		GList* _tmp29_;
		gconstpointer _tmp30_;
		_tmp29_ = gtk_application_get_windows ((GtkApplication*) self);
		_tmp30_ = _tmp29_->data;
		gtk_window_present ((GtkWindow*) _tmp30_);
		_g_variant_unref0 (mapping_dic);
		_g_object_unref0 (setting);
		_g_object_unref0 (plugsmanager);
		return;
	}
	_tmp31_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->loaded_plugs);
	self->priv->loaded_plugs = _tmp31_;
	_tmp32_ = gee_array_list_new (SWITCHBOARD_TYPE_PLUG, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->previous_plugs);
	self->previous_plugs = _tmp32_;
	switchboard_switchboard_app_build (self);
	gtk_main ();
	_g_variant_unref0 (mapping_dic);
	_g_object_unref0 (setting);
	_g_object_unref0 (plugsmanager);
}

void
switchboard_switchboard_app_hide_alert (SwitchboardSwitchboardApp* self)
{
	GtkStack* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->stack;
	gtk_stack_set_visible_child_full (_tmp0_, "main", GTK_STACK_TRANSITION_TYPE_NONE);
}

void
switchboard_switchboard_app_show_alert (SwitchboardSwitchboardApp* self,
                                        const gchar* primary_text,
                                        const gchar* secondary_text,
                                        const gchar* icon_name)
{
	GraniteWidgetsAlertView* _tmp0_;
	GraniteWidgetsAlertView* _tmp1_;
	GraniteWidgetsAlertView* _tmp2_;
	GraniteWidgetsAlertView* _tmp3_;
	GtkStack* _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (primary_text != NULL);
	g_return_if_fail (secondary_text != NULL);
	g_return_if_fail (icon_name != NULL);
	_tmp0_ = self->priv->alert_view;
	gtk_widget_show_all ((GtkWidget*) _tmp0_);
	_tmp1_ = self->priv->alert_view;
	granite_widgets_alert_view_set_title (_tmp1_, primary_text);
	_tmp2_ = self->priv->alert_view;
	granite_widgets_alert_view_set_description (_tmp2_, secondary_text);
	_tmp3_ = self->priv->alert_view;
	granite_widgets_alert_view_set_icon_name (_tmp3_, icon_name);
	_tmp4_ = self->priv->stack;
	gtk_stack_set_visible_child_full (_tmp4_, "alert", GTK_STACK_TRANSITION_TYPE_NONE);
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		SwitchboardSwitchboardApp* self;
		self = _data1_->self;
		_g_object_unref0 (_data1_->plug);
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}

static gboolean
__lambda7_ (Block1Data* _data1_,
            SwitchboardSearchEntry* entry)
{
	SwitchboardSwitchboardApp* self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean result = FALSE;
	self = _data1_->self;
	_tmp0_ = switchboard_plug_get_display_name (_data1_->plug);
	_tmp1_ = _tmp0_;
	_tmp2_ = (*entry).plug_name;
	if (g_strcmp0 (_tmp1_, _tmp2_) == 0) {
		const gchar* _tmp3_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		_tmp3_ = (*entry).open_window;
		if (_tmp3_ == NULL) {
			switchboard_plug_search_callback (_data1_->plug, "");
		} else {
			const gchar* _tmp4_;
			_tmp4_ = (*entry).open_window;
			switchboard_plug_search_callback (_data1_->plug, _tmp4_);
		}
		_tmp5_ = (*entry).open_window;
		_tmp6_ = switchboard_plug_get_display_name (_data1_->plug);
		_tmp7_ = _tmp6_;
		g_debug ("Switchboard.vala:195: open section:%s of plug: %s", _tmp5_, _tmp7_);
		result = TRUE;
		_switchboard_search_entry_free0 (entry);
		return result;
	}
	result = FALSE;
	_switchboard_search_entry_free0 (entry);
	return result;
}

static gboolean
___lambda7__gee_forall_func (gpointer g,
                             gpointer self)
{
	gboolean result;
	result = __lambda7_ (self, (SwitchboardSearchEntry*) g);
	return result;
}

static gboolean
__lambda6_ (Block1Data* _data1_)
{
	SwitchboardSwitchboardApp* self;
	GeeLinkedList* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	SwitchboardCategoryView* _tmp11_;
	GeeArrayList* _tmp12_;
	GeeArrayList* _tmp13_;
	gboolean _tmp14_ = FALSE;
	GeeArrayList* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	GtkButton* _tmp22_;
	const gchar* _tmp23_;
	GtkButton* _tmp24_;
	GtkHeaderBar* _tmp25_;
	const gchar* _tmp26_;
	const gchar* _tmp27_;
	SwitchboardPlug* _tmp28_;
	const gchar* _tmp29_;
	gboolean result = FALSE;
	self = _data1_->self;
	_tmp0_ = self->priv->loaded_plugs;
	_tmp1_ = switchboard_plug_get_code_name (_data1_->plug);
	_tmp2_ = _tmp1_;
	if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, _tmp2_)) {
		GtkStack* _tmp3_;
		GtkWidget* _tmp4_;
		GtkWidget* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		GeeLinkedList* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		_tmp3_ = self->priv->stack;
		_tmp4_ = switchboard_plug_get_widget (_data1_->plug);
		_tmp5_ = _tmp4_;
		_tmp6_ = switchboard_plug_get_code_name (_data1_->plug);
		_tmp7_ = _tmp6_;
		gtk_stack_add_named (_tmp3_, _tmp5_, _tmp7_);
		_g_object_unref0 (_tmp5_);
		_tmp8_ = self->priv->loaded_plugs;
		_tmp9_ = switchboard_plug_get_code_name (_data1_->plug);
		_tmp10_ = _tmp9_;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp8_, _tmp10_);
	}
	_tmp11_ = self->category_view;
	_tmp12_ = switchboard_category_view_get_plug_search_result (_tmp11_);
	_tmp13_ = _tmp12_;
	gee_abstract_collection_foreach ((GeeAbstractCollection*) _tmp13_, ___lambda7__gee_forall_func, _data1_);
	_tmp15_ = self->previous_plugs;
	_tmp16_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp15_);
	_tmp17_ = _tmp16_;
	if (_tmp17_ == 0) {
		_tmp14_ = TRUE;
	} else {
		GeeArrayList* _tmp18_;
		gpointer _tmp19_;
		SwitchboardPlug* _tmp20_;
		_tmp18_ = self->previous_plugs;
		_tmp19_ = gee_abstract_list_get ((GeeAbstractList*) _tmp18_, 0);
		_tmp20_ = (SwitchboardPlug*) _tmp19_;
		_tmp14_ = _tmp20_ != _data1_->plug;
		_g_object_unref0 (_tmp20_);
	}
	if (_tmp14_) {
		GeeArrayList* _tmp21_;
		_tmp21_ = self->previous_plugs;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp21_, _data1_->plug);
	}
	_tmp22_ = self->priv->navigation_button;
	_tmp23_ = self->priv->all_settings_label;
	gtk_button_set_label (_tmp22_, _tmp23_);
	_tmp24_ = self->priv->navigation_button;
	gtk_widget_show ((GtkWidget*) _tmp24_);
	_tmp25_ = self->priv->headerbar;
	_tmp26_ = switchboard_plug_get_display_name (_data1_->plug);
	_tmp27_ = _tmp26_;
	gtk_header_bar_set_title (_tmp25_, _tmp27_);
	_tmp28_ = _g_object_ref0 (_data1_->plug);
	_g_object_unref0 (self->current_plug);
	self->current_plug = _tmp28_;
	_tmp29_ = switchboard_switchboard_app_open_window;
	if (_tmp29_ != NULL) {
		const gchar* _tmp30_;
		_tmp30_ = switchboard_switchboard_app_open_window;
		switchboard_plug_search_callback (_data1_->plug, _tmp30_);
		_g_free0 (switchboard_switchboard_app_open_window);
		switchboard_switchboard_app_open_window = NULL;
	}
	switchboard_switchboard_app_switch_to_plug (self, _data1_->plug);
	result = FALSE;
	return result;
}

static gboolean
___lambda6__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda6_ (self);
	return result;
}

void
switchboard_switchboard_app_load_plug (SwitchboardSwitchboardApp* self,
                                       SwitchboardPlug* plug)
{
	Block1Data* _data1_;
	SwitchboardPlug* _tmp0_;
	gint priority = 0;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (plug != NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (plug);
	_g_object_unref0 (_data1_->plug);
	_data1_->plug = _tmp0_;
	priority = G_PRIORITY_DEFAULT_IDLE;
	_tmp1_ = switchboard_plug_get_code_name (_data1_->plug);
	_tmp2_ = _tmp1_;
	if (string_contains (_tmp2_, "-gcc-")) {
		priority = G_PRIORITY_LOW;
	}
	g_idle_add_full (priority, ___lambda6__gsource_func, block1_data_ref (_data1_), block1_data_unref);
	block1_data_unref (_data1_);
	_data1_ = NULL;
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		SwitchboardSwitchboardApp* self;
		self = _data2_->self;
		_g_object_unref0 (_data2_->settings);
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}

static void
__lambda12_ (SwitchboardSwitchboardApp* self,
             SwitchboardPlug* plug)
{
	g_return_if_fail (plug != NULL);
	switchboard_switchboard_app_load_plug (self, plug);
}

static void
___lambda12__switchboard_category_view_plug_selected (SwitchboardCategoryView* _sender,
                                                      SwitchboardPlug* plug,
                                                      gpointer self)
{
	__lambda12_ ((SwitchboardSwitchboardApp*) self, plug);
}

static void
_switchboard_switchboard_app_handle_navigation_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                                  gpointer self)
{
	switchboard_switchboard_app_handle_navigation_button_clicked ((SwitchboardSwitchboardApp*) self);
}

static void
__lambda13_ (SwitchboardSwitchboardApp* self)
{
	SwitchboardCategoryView* _tmp0_;
	GtkSearchEntry* _tmp1_;
	const gchar* _tmp2_;
	_tmp0_ = self->category_view;
	_tmp1_ = self->priv->_search_box;
	_tmp2_ = gtk_entry_get_text ((GtkEntry*) _tmp1_);
	switchboard_category_view_filter_plugs (_tmp0_, _tmp2_);
}

static void
___lambda13__gtk_editable_changed (GtkEditable* _sender,
                                   gpointer self)
{
	__lambda13_ ((SwitchboardSwitchboardApp*) self);
}

static gboolean
__lambda14_ (SwitchboardSwitchboardApp* self,
             GdkEventKey* event)
{
	gboolean result = FALSE;
	g_return_val_if_fail (event != NULL, FALSE);
	switch (event->keyval) {
		case GDK_KEY_Return:
		{
			SwitchboardCategoryView* _tmp0_;
			_tmp0_ = self->category_view;
			switchboard_category_view_activate_first_item (_tmp0_);
			result = TRUE;
			return result;
		}
		case GDK_KEY_Escape:
		{
			GtkSearchEntry* _tmp1_;
			_tmp1_ = self->priv->_search_box;
			gtk_entry_set_text ((GtkEntry*) _tmp1_, "");
			result = TRUE;
			return result;
		}
		default:
		{
			break;
		}
	}
	result = FALSE;
	return result;
}

static gboolean
___lambda14__gtk_widget_key_press_event (GtkWidget* _sender,
                                         GdkEventKey* event,
                                         gpointer self)
{
	gboolean result;
	result = __lambda14_ ((SwitchboardSwitchboardApp*) self, event);
	return result;
}

static void
__lambda15_ (SwitchboardSwitchboardApp* self)
{
	GtkButton* _tmp0_;
	_tmp0_ = self->priv->navigation_button;
	gtk_button_clicked (_tmp0_);
}

static void
___lambda15__g_simple_action_activate (GSimpleAction* _sender,
                                       GVariant* parameter,
                                       gpointer self)
{
	__lambda15_ ((SwitchboardSwitchboardApp*) self);
}

static void
__lambda16_ (SwitchboardSwitchboardApp* self)
{
	GtkWindow* _tmp0_;
	_tmp0_ = self->priv->main_window;
	gtk_widget_destroy ((GtkWidget*) _tmp0_);
}

static void
___lambda16__g_simple_action_activate (GSimpleAction* _sender,
                                       GVariant* parameter,
                                       gpointer self)
{
	__lambda16_ ((SwitchboardSwitchboardApp*) self);
}

static gboolean
__lambda17_ (SwitchboardSwitchboardApp* self,
             GdkEventButton* event)
{
	gboolean result = FALSE;
	g_return_val_if_fail (event != NULL, FALSE);
	if (event->button == ((guint) 8)) {
		GtkButton* _tmp0_;
		_tmp0_ = self->priv->navigation_button;
		gtk_button_clicked (_tmp0_);
	}
	result = FALSE;
	return result;
}

static gboolean
___lambda17__gtk_widget_button_release_event (GtkWidget* _sender,
                                              GdkEventButton* event,
                                              gpointer self)
{
	gboolean result;
	result = __lambda17_ ((SwitchboardSwitchboardApp*) self, event);
	return result;
}

static void
_switchboard_switchboard_app_shut_down_gtk_widget_destroy (GtkWidget* _sender,
                                                           gpointer self)
{
	switchboard_switchboard_app_shut_down ((SwitchboardSwitchboardApp*) self);
}

static gboolean
__lambda18_ (Block2Data* _data2_)
{
	SwitchboardSwitchboardApp* self;
	GSettings* _tmp0_;
	gboolean result = FALSE;
	self = _data2_->self;
	_tmp0_ = _data2_->settings;
	if (g_settings_get_enum (_tmp0_, "window-state") == ((gint) SWITCHBOARD_WINDOW_STATE_NORMAL)) {
		gint width = 0;
		gint height = 0;
		gint x = 0;
		gint y = 0;
		GtkWindow* _tmp1_;
		gint _tmp2_ = 0;
		gint _tmp3_ = 0;
		GtkWindow* _tmp4_;
		gint _tmp5_ = 0;
		gint _tmp6_ = 0;
		gchar** position = NULL;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar** _tmp9_;
		gint position_length1;
		gint _position_size_;
		GSettings* _tmp10_;
		GSettings* _tmp11_;
		GSettings* _tmp12_;
		gchar** _tmp13_;
		gint _tmp13__length1;
		_tmp1_ = self->priv->main_window;
		gtk_window_get_size (_tmp1_, &_tmp2_, &_tmp3_);
		width = _tmp2_;
		height = _tmp3_;
		_tmp4_ = self->priv->main_window;
		gtk_window_get_position (_tmp4_, &_tmp5_, &_tmp6_);
		x = _tmp5_;
		y = _tmp6_;
		_tmp7_ = g_strdup_printf ("%i", x);
		_tmp8_ = g_strdup_printf ("%i", y);
		_tmp9_ = g_new0 (gchar*, 2 + 1);
		_tmp9_[0] = _tmp7_;
		_tmp9_[1] = _tmp8_;
		position = _tmp9_;
		position_length1 = 2;
		_position_size_ = position_length1;
		_tmp10_ = _data2_->settings;
		g_settings_set_int (_tmp10_, "window-width", width);
		_tmp11_ = _data2_->settings;
		g_settings_set_int (_tmp11_, "window-height", height);
		_tmp12_ = _data2_->settings;
		_tmp13_ = position;
		_tmp13__length1 = position_length1;
		g_settings_set_strv (_tmp12_, "position", _tmp13_);
		position = (_vala_array_free (position, position_length1, (GDestroyNotify) g_free), NULL);
	}
	result = FALSE;
	return result;
}

static gboolean
___lambda18__gtk_widget_delete_event (GtkWidget* _sender,
                                      GdkEventAny* event,
                                      gpointer self)
{
	gboolean result;
	result = __lambda18_ (self);
	return result;
}

static gboolean
_vala_uint_array_contains (guint * stack,
                           gssize stack_length,
                           const guint needle)
{
	gssize i;
	for (i = 0; i < stack_length; i++) {
		if (needle == stack[i]) {
			return TRUE;
		}
	}
	return FALSE;
}

static gboolean
__lambda19_ (SwitchboardSwitchboardApp* self,
             GdkEventKey* event)
{
	gboolean _tmp0_ = FALSE;
	GtkSearchEntry* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp5_ = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp1_ = self->priv->_search_box;
	g_object_get ((GtkWidget*) _tmp1_, "has-focus", &_tmp2_, NULL);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		_tmp0_ = event->keyval == GDK_KEY_Down;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		SwitchboardCategoryView* _tmp4_;
		_tmp4_ = self->category_view;
		switchboard_category_view_grab_focus_first_icon_view (_tmp4_);
		result = FALSE;
		return result;
	}
	if (_vala_uint_array_contains (SWITCHBOARD_SWITCHBOARD_APP_NAVIGATION_KEYS, G_N_ELEMENTS (SWITCHBOARD_SWITCHBOARD_APP_NAVIGATION_KEYS), event->keyval)) {
		result = FALSE;
		return result;
	}
	if (event->is_modifier == ((guint) 0)) {
		GtkSearchEntry* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
		_tmp6_ = self->priv->_search_box;
		g_object_get ((GtkWidget*) _tmp6_, "has-focus", &_tmp7_, NULL);
		_tmp8_ = _tmp7_;
		_tmp5_ = !_tmp8_;
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		GtkSearchEntry* _tmp9_;
		_tmp9_ = self->priv->_search_box;
		gtk_widget_grab_focus ((GtkWidget*) _tmp9_);
	}
	result = FALSE;
	return result;
}

static gboolean
___lambda19__gtk_widget_key_press_event (GtkWidget* _sender,
                                         GdkEventKey* event,
                                         gpointer self)
{
	gboolean result;
	result = __lambda19_ ((SwitchboardSwitchboardApp*) self, event);
	return result;
}

static gboolean
__lambda20_ (Block2Data* _data2_,
             GdkEventWindowState* event)
{
	SwitchboardSwitchboardApp* self;
	gboolean result = FALSE;
	self = _data2_->self;
	g_return_val_if_fail (event != NULL, FALSE);
	if (event->new_window_state == GDK_WINDOW_STATE_MAXIMIZED) {
		GSettings* _tmp0_;
		_tmp0_ = _data2_->settings;
		g_settings_set_enum (_tmp0_, "window-state", (gint) SWITCHBOARD_WINDOW_STATE_MAXIMIZED);
	} else {
		GSettings* _tmp1_;
		_tmp1_ = _data2_->settings;
		g_settings_set_enum (_tmp1_, "window-state", (gint) SWITCHBOARD_WINDOW_STATE_NORMAL);
	}
	result = FALSE;
	return result;
}

static gboolean
___lambda20__gtk_widget_window_state_event (GtkWidget* _sender,
                                            GdkEventWindowState* event,
                                            gpointer self)
{
	gboolean result;
	result = __lambda20_ (self, event);
	return result;
}

static void
__lambda21_ (SwitchboardSwitchboardApp* self)
{
	if (switchboard_switchboard_app_opened_directly) {
		GtkSearchEntry* _tmp0_;
		_tmp0_ = self->priv->_search_box;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, FALSE);
	}
}

static void
___lambda21__gtk_widget_size_allocate (GtkWidget* _sender,
                                       GtkAllocation* allocation,
                                       gpointer self)
{
	__lambda21_ ((SwitchboardSwitchboardApp*) self);
}

static void
switchboard_switchboard_app_build (SwitchboardSwitchboardApp* self)
{
	Block2Data* _data2_;
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkSearchEntry* _tmp3_;
	GtkSearchEntry* _tmp4_;
	GtkSearchEntry* _tmp5_;
	GtkSearchEntry* _tmp6_;
	GtkHeaderBar* _tmp7_;
	GtkHeaderBar* _tmp8_;
	GtkHeaderBar* _tmp9_;
	GtkHeaderBar* _tmp10_;
	GtkHeaderBar* _tmp11_;
	GtkButton* _tmp12_;
	GtkHeaderBar* _tmp13_;
	GtkSearchEntry* _tmp14_;
	const gchar* _tmp15_;
	SwitchboardCategoryView* _tmp16_;
	SwitchboardCategoryView* _tmp17_;
	SwitchboardCategoryView* _tmp18_;
	SwitchboardCategoryView* _tmp19_;
	GtkScrolledWindow* _tmp20_;
	GtkScrolledWindow* _tmp21_;
	SwitchboardCategoryView* _tmp22_;
	GraniteWidgetsAlertView* _tmp23_;
	GraniteWidgetsAlertView* _tmp24_;
	GtkStyleContext* _tmp25_;
	GtkStack* _tmp26_;
	GtkStack* _tmp27_;
	GtkStack* _tmp28_;
	GraniteWidgetsAlertView* _tmp29_;
	GtkStack* _tmp30_;
	GtkScrolledWindow* _tmp31_;
	GSettings* _tmp32_;
	GtkWindow* _tmp33_;
	GtkWindow* _tmp34_;
	GtkWindow* _tmp35_;
	GtkWindow* _tmp36_;
	GtkWindow* _tmp37_;
	GtkStack* _tmp38_;
	GtkWindow* _tmp39_;
	GSettings* _tmp40_;
	GSettings* _tmp41_;
	GtkWindow* _tmp42_;
	GtkWindow* _tmp43_;
	GtkHeaderBar* _tmp44_;
	GSettings* _tmp45_;
	GtkWindow* _tmp57_;
	GtkButton* _tmp58_;
	GtkWindow* _tmp59_;
	GtkButton* _tmp60_;
	GtkSearchEntry* _tmp61_;
	GtkSearchEntry* _tmp62_;
	GSimpleAction* back_action = NULL;
	GSimpleAction* _tmp63_;
	GSimpleAction* quit_action = NULL;
	GSimpleAction* _tmp64_;
	GSimpleAction* _tmp65_;
	GSimpleAction* _tmp66_;
	gchar* _tmp67_;
	gchar* _tmp68_;
	gchar** _tmp69_;
	gchar** _tmp70_;
	gint _tmp70__length1;
	gchar* _tmp71_;
	gchar** _tmp72_;
	gchar** _tmp73_;
	gint _tmp73__length1;
	GSimpleAction* _tmp74_;
	GSimpleAction* _tmp75_;
	GtkWindow* _tmp76_;
	GtkWindow* _tmp77_;
	GtkWindow* _tmp78_;
	GtkWindow* _tmp79_;
	GtkWindow* _tmp80_;
	GtkWindow* _tmp81_;
	SwitchboardPlugsManager* _tmp82_;
	SwitchboardPlugsManager* _tmp83_;
	gboolean _tmp84_;
	g_return_if_fail (self != NULL);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = g_object_ref (self);
	_tmp0_ = (GtkButton*) gtk_button_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->navigation_button);
	self->priv->navigation_button = _tmp0_;
	_tmp1_ = self->priv->navigation_button;
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) _tmp1_);
	gtk_style_context_add_class (_tmp2_, "back-button");
	_tmp3_ = (GtkSearchEntry*) gtk_search_entry_new ();
	g_object_ref_sink (_tmp3_);
	_tmp4_ = _tmp3_;
	switchboard_switchboard_app_set_search_box (self, _tmp4_);
	_g_object_unref0 (_tmp4_);
	_tmp5_ = self->priv->_search_box;
	gtk_entry_set_placeholder_text ((GtkEntry*) _tmp5_, _ ("Search Settings"));
	_tmp6_ = self->priv->_search_box;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, FALSE);
	_tmp7_ = (GtkHeaderBar*) gtk_header_bar_new ();
	g_object_ref_sink (_tmp7_);
	_g_object_unref0 (self->priv->headerbar);
	self->priv->headerbar = _tmp7_;
	_tmp8_ = self->priv->headerbar;
	gtk_header_bar_set_has_subtitle (_tmp8_, FALSE);
	_tmp9_ = self->priv->headerbar;
	gtk_header_bar_set_show_close_button (_tmp9_, TRUE);
	_tmp10_ = self->priv->headerbar;
	gtk_header_bar_set_title (_tmp10_, _ ("System Settings"));
	_tmp11_ = self->priv->headerbar;
	_tmp12_ = self->priv->navigation_button;
	gtk_header_bar_pack_start (_tmp11_, (GtkWidget*) _tmp12_);
	_tmp13_ = self->priv->headerbar;
	_tmp14_ = self->priv->_search_box;
	gtk_header_bar_pack_end (_tmp13_, (GtkWidget*) _tmp14_);
	_tmp15_ = switchboard_switchboard_app_plug_to_open;
	_tmp16_ = switchboard_category_view_new (_tmp15_);
	g_object_ref_sink (_tmp16_);
	_g_object_unref0 (self->category_view);
	self->category_view = _tmp16_;
	_tmp17_ = self->category_view;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp17_, 12);
	_tmp18_ = self->category_view;
	g_signal_connect_object (_tmp18_, "plug-selected", (GCallback) ___lambda12__switchboard_category_view_plug_selected, self, 0);
	_tmp19_ = self->category_view;
	switchboard_category_view_load_default_plugs (_tmp19_, NULL, NULL);
	_tmp20_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
	g_object_ref_sink (_tmp20_);
	_g_object_unref0 (self->priv->category_scrolled);
	self->priv->category_scrolled = _tmp20_;
	_tmp21_ = self->priv->category_scrolled;
	_tmp22_ = self->category_view;
	gtk_container_add ((GtkContainer*) _tmp21_, (GtkWidget*) _tmp22_);
	_tmp23_ = granite_widgets_alert_view_new ("", "", "");
	g_object_ref_sink (_tmp23_);
	_g_object_unref0 (self->priv->alert_view);
	self->priv->alert_view = _tmp23_;
	_tmp24_ = self->priv->alert_view;
	_tmp25_ = gtk_widget_get_style_context ((GtkWidget*) _tmp24_);
	gtk_style_context_add_class (_tmp25_, GTK_STYLE_CLASS_DIM_LABEL);
	_tmp26_ = (GtkStack*) gtk_stack_new ();
	g_object_ref_sink (_tmp26_);
	_g_object_unref0 (self->priv->stack);
	self->priv->stack = _tmp26_;
	_tmp27_ = self->priv->stack;
	gtk_stack_set_transition_type (_tmp27_, GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT_RIGHT);
	_tmp28_ = self->priv->stack;
	_tmp29_ = self->priv->alert_view;
	gtk_stack_add_named (_tmp28_, (GtkWidget*) _tmp29_, "alert");
	_tmp30_ = self->priv->stack;
	_tmp31_ = self->priv->category_scrolled;
	gtk_stack_add_named (_tmp30_, (GtkWidget*) _tmp31_, "main");
	_tmp32_ = g_settings_new ("io.elementary.switchboard.saved-state");
	_data2_->settings = _tmp32_;
	_tmp33_ = (GtkWindow*) gtk_window_new (GTK_WINDOW_TOPLEVEL);
	g_object_ref_sink (_tmp33_);
	_g_object_unref0 (self->priv->main_window);
	self->priv->main_window = _tmp33_;
	_tmp34_ = self->priv->main_window;
	gtk_window_set_application (_tmp34_, (GtkApplication*) self);
	_tmp35_ = self->priv->main_window;
	gtk_window_set_icon_name (_tmp35_, "preferences-desktop");
	_tmp36_ = self->priv->main_window;
	gtk_window_set_title (_tmp36_, _ ("System Settings"));
	_tmp37_ = self->priv->main_window;
	_tmp38_ = self->priv->stack;
	gtk_container_add ((GtkContainer*) _tmp37_, (GtkWidget*) _tmp38_);
	_tmp39_ = self->priv->main_window;
	_tmp40_ = _data2_->settings;
	_tmp41_ = _data2_->settings;
	gtk_window_set_default_size (_tmp39_, g_settings_get_int (_tmp40_, "window-width"), g_settings_get_int (_tmp41_, "window-height"));
	_tmp42_ = self->priv->main_window;
	gtk_widget_set_size_request ((GtkWidget*) _tmp42_, 910, 640);
	_tmp43_ = self->priv->main_window;
	_tmp44_ = self->priv->headerbar;
	gtk_window_set_titlebar (_tmp43_, (GtkWidget*) _tmp44_);
	_tmp45_ = _data2_->settings;
	if (g_settings_get_enum (_tmp45_, "window-state") == ((gint) SWITCHBOARD_WINDOW_STATE_MAXIMIZED)) {
		GtkWindow* _tmp46_;
		_tmp46_ = self->priv->main_window;
		gtk_window_maximize (_tmp46_);
	} else {
		gchar** position = NULL;
		GSettings* _tmp47_;
		gchar** _tmp48_;
		gchar** _tmp49_;
		gint position_length1;
		gint _position_size_;
		gchar** _tmp50_;
		gint _tmp50__length1;
		_tmp47_ = _data2_->settings;
		_tmp49_ = _tmp48_ = g_settings_get_strv (_tmp47_, "position");
		position = _tmp49_;
		position_length1 = _vala_array_length (_tmp48_);
		_position_size_ = position_length1;
		_tmp50_ = position;
		_tmp50__length1 = position_length1;
		if (_tmp50__length1 != 2) {
			GtkWindow* _tmp51_;
			_tmp51_ = self->priv->main_window;
			g_object_set (_tmp51_, "window-position", GTK_WIN_POS_CENTER, NULL);
		} else {
			GtkWindow* _tmp52_;
			gchar** _tmp53_;
			gint _tmp53__length1;
			const gchar* _tmp54_;
			gchar** _tmp55_;
			gint _tmp55__length1;
			const gchar* _tmp56_;
			_tmp52_ = self->priv->main_window;
			_tmp53_ = position;
			_tmp53__length1 = position_length1;
			_tmp54_ = _tmp53_[0];
			_tmp55_ = position;
			_tmp55__length1 = position_length1;
			_tmp56_ = _tmp55_[1];
			gtk_window_move (_tmp52_, atoi (_tmp54_), atoi (_tmp56_));
		}
		position = (_vala_array_free (position, position_length1, (GDestroyNotify) g_free), NULL);
	}
	_tmp57_ = self->priv->main_window;
	gtk_widget_show_all ((GtkWidget*) _tmp57_);
	_tmp58_ = self->priv->navigation_button;
	gtk_widget_hide ((GtkWidget*) _tmp58_);
	_tmp59_ = self->priv->main_window;
	gtk_application_add_window ((GtkApplication*) self, _tmp59_);
	_tmp60_ = self->priv->navigation_button;
	g_signal_connect_object (_tmp60_, "clicked", (GCallback) _switchboard_switchboard_app_handle_navigation_button_clicked_gtk_button_clicked, self, 0);
	_tmp61_ = self->priv->_search_box;
	g_signal_connect_object ((GtkEditable*) _tmp61_, "changed", (GCallback) ___lambda13__gtk_editable_changed, self, 0);
	_tmp62_ = self->priv->_search_box;
	g_signal_connect_object ((GtkWidget*) _tmp62_, "key-press-event", (GCallback) ___lambda14__gtk_widget_key_press_event, self, 0);
	_tmp63_ = g_simple_action_new ("back", NULL);
	back_action = _tmp63_;
	_tmp64_ = g_simple_action_new ("quit", NULL);
	quit_action = _tmp64_;
	_tmp65_ = back_action;
	g_action_map_add_action ((GActionMap*) self, (GAction*) _tmp65_);
	_tmp66_ = quit_action;
	g_action_map_add_action ((GActionMap*) self, (GAction*) _tmp66_);
	_tmp67_ = g_strdup ("<Alt>Left");
	_tmp68_ = g_strdup ("Back");
	_tmp69_ = g_new0 (gchar*, 2 + 1);
	_tmp69_[0] = _tmp67_;
	_tmp69_[1] = _tmp68_;
	_tmp70_ = _tmp69_;
	_tmp70__length1 = 2;
	gtk_application_set_accels_for_action ((GtkApplication*) self, "app.back", _tmp70_);
	_tmp70_ = (_vala_array_free (_tmp70_, _tmp70__length1, (GDestroyNotify) g_free), NULL);
	_tmp71_ = g_strdup ("<Control>q");
	_tmp72_ = g_new0 (gchar*, 1 + 1);
	_tmp72_[0] = _tmp71_;
	_tmp73_ = _tmp72_;
	_tmp73__length1 = 1;
	gtk_application_set_accels_for_action ((GtkApplication*) self, "app.quit", _tmp73_);
	_tmp73_ = (_vala_array_free (_tmp73_, _tmp73__length1, (GDestroyNotify) g_free), NULL);
	_tmp74_ = back_action;
	g_signal_connect_object (_tmp74_, "activate", (GCallback) ___lambda15__g_simple_action_activate, self, 0);
	_tmp75_ = quit_action;
	g_signal_connect_object (_tmp75_, "activate", (GCallback) ___lambda16__g_simple_action_activate, self, 0);
	_tmp76_ = self->priv->main_window;
	g_signal_connect_object ((GtkWidget*) _tmp76_, "button-release-event", (GCallback) ___lambda17__gtk_widget_button_release_event, self, 0);
	_tmp77_ = self->priv->main_window;
	g_signal_connect_object ((GtkWidget*) _tmp77_, "destroy", (GCallback) _switchboard_switchboard_app_shut_down_gtk_widget_destroy, self, 0);
	_tmp78_ = self->priv->main_window;
	g_signal_connect_data ((GtkWidget*) _tmp78_, "delete-event", (GCallback) ___lambda18__gtk_widget_delete_event, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	_tmp79_ = self->priv->main_window;
	g_signal_connect_object ((GtkWidget*) _tmp79_, "key-press-event", (GCallback) ___lambda19__gtk_widget_key_press_event, self, 0);
	_tmp80_ = self->priv->main_window;
	g_signal_connect_data ((GtkWidget*) _tmp80_, "window-state-event", (GCallback) ___lambda20__gtk_widget_window_state_event, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	_tmp81_ = self->priv->main_window;
	g_signal_connect_object ((GtkWidget*) _tmp81_, "size-allocate", (GCallback) ___lambda21__gtk_widget_size_allocate, self, 0);
	_tmp82_ = switchboard_plugs_manager_get_default ();
	_tmp83_ = _tmp82_;
	_tmp84_ = switchboard_plugs_manager_has_plugs (_tmp83_) == FALSE;
	_g_object_unref0 (_tmp83_);
	if (_tmp84_) {
		GtkSearchEntry* _tmp85_;
		switchboard_switchboard_app_show_alert (self, _ ("No Settings Found"), _ ("Install some and re-launch Switchboard."), "dialog-warning");
		_tmp85_ = self->priv->_search_box;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp85_, FALSE);
	} else {
		GtkSearchEntry* _tmp86_;
		GtkSearchEntry* _tmp87_;
		_tmp86_ = self->priv->_search_box;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp86_, TRUE);
		_tmp87_ = self->priv->_search_box;
		g_object_set ((GtkWidget*) _tmp87_, "has-focus", TRUE, NULL);
	}
	_g_object_unref0 (quit_action);
	_g_object_unref0 (back_action);
	block2_data_unref (_data2_);
	_data2_ = NULL;
}

static void
switchboard_switchboard_app_shut_down (SwitchboardSwitchboardApp* self)
{
	SwitchboardPlug* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->current_plug;
	if (_tmp0_ != NULL) {
		SwitchboardPlug* _tmp1_;
		_tmp1_ = self->current_plug;
		switchboard_plug_hidden (_tmp1_);
	}
	gtk_main_quit ();
}

static void
switchboard_switchboard_app_handle_navigation_button_clicked (SwitchboardSwitchboardApp* self)
{
	GtkButton* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->navigation_button;
	_tmp1_ = gtk_button_get_label (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->priv->all_settings_label;
	if (g_strcmp0 (_tmp2_, _tmp3_) == 0) {
		GtkSearchEntry* _tmp4_;
		GtkButton* _tmp5_;
		switchboard_switchboard_app_opened_directly = FALSE;
		_tmp4_ = self->priv->_search_box;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, TRUE);
		switchboard_switchboard_app_switch_to_icons (self);
		_tmp5_ = self->priv->navigation_button;
		gtk_widget_hide ((GtkWidget*) _tmp5_);
	} else {
		gboolean _tmp6_ = FALSE;
		GeeArrayList* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		_tmp7_ = self->previous_plugs;
		_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp7_);
		_tmp9_ = _tmp8_;
		if (_tmp9_ > 0) {
			GtkStack* _tmp10_;
			const gchar* _tmp11_;
			_tmp10_ = self->priv->stack;
			_tmp11_ = gtk_stack_get_visible_child_name (_tmp10_);
			_tmp6_ = g_strcmp0 (_tmp11_, "main") != 0;
		} else {
			_tmp6_ = FALSE;
		}
		if (_tmp6_) {
			SwitchboardPlug* _tmp12_;
			GeeArrayList* _tmp14_;
			gpointer _tmp15_;
			SwitchboardPlug* _tmp16_;
			GeeArrayList* _tmp17_;
			gpointer _tmp18_;
			SwitchboardPlug* _tmp19_;
			_tmp12_ = self->current_plug;
			if (_tmp12_ != NULL) {
				SwitchboardPlug* _tmp13_;
				_tmp13_ = self->current_plug;
				switchboard_plug_hidden (_tmp13_);
			}
			_tmp14_ = self->previous_plugs;
			_tmp15_ = gee_abstract_list_get ((GeeAbstractList*) _tmp14_, 0);
			_tmp16_ = (SwitchboardPlug*) _tmp15_;
			switchboard_switchboard_app_load_plug (self, _tmp16_);
			_g_object_unref0 (_tmp16_);
			_tmp17_ = self->previous_plugs;
			_tmp18_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp17_, 0);
			_tmp19_ = (SwitchboardPlug*) _tmp18_;
			_g_object_unref0 (_tmp19_);
		} else {
			SwitchboardPlug* _tmp20_;
			_tmp20_ = self->current_plug;
			switchboard_switchboard_app_switch_to_plug (self, _tmp20_);
		}
	}
}

static gboolean
switchboard_switchboard_app_load_setting_path (SwitchboardSwitchboardApp* self,
                                               const gchar* setting_path,
                                               SwitchboardPlugsManager* plugsmanager)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (setting_path != NULL, FALSE);
	g_return_val_if_fail (plugsmanager != NULL, FALSE);
	{
		GeeIterator* _plug_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
		_tmp0_ = switchboard_plugs_manager_get_plugs (plugsmanager);
		_tmp1_ = _tmp0_;
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
		_tmp3_ = _tmp2_;
		_g_object_unref0 (_tmp1_);
		_plug_it = _tmp3_;
		while (TRUE) {
			GeeIterator* _tmp4_;
			SwitchboardPlug* plug = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			GeeTreeMap* supported_settings = NULL;
			SwitchboardPlug* _tmp7_;
			GeeTreeMap* _tmp8_;
			GeeTreeMap* _tmp9_;
			GeeTreeMap* _tmp10_;
			GeeTreeMap* _tmp11_;
			GeeTreeMap* _tmp12_;
			_tmp4_ = _plug_it;
			if (!gee_iterator_next (_tmp4_)) {
				break;
			}
			_tmp5_ = _plug_it;
			_tmp6_ = gee_iterator_get (_tmp5_);
			plug = (SwitchboardPlug*) _tmp6_;
			_tmp7_ = plug;
			_tmp8_ = switchboard_plug_get_supported_settings (_tmp7_);
			_tmp9_ = _tmp8_;
			_tmp10_ = _g_object_ref0 (_tmp9_);
			supported_settings = _tmp10_;
			_tmp11_ = supported_settings;
			if (_tmp11_ == NULL) {
				_g_object_unref0 (supported_settings);
				_g_object_unref0 (plug);
				continue;
			}
			_tmp12_ = supported_settings;
			if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp12_, setting_path)) {
				SwitchboardPlug* _tmp13_;
				SwitchboardPlug* _tmp15_;
				GeeTreeMap* _tmp16_;
				gpointer _tmp17_;
				_tmp13_ = self->current_plug;
				if (_tmp13_ != NULL) {
					SwitchboardPlug* _tmp14_;
					_tmp14_ = self->current_plug;
					switchboard_plug_hidden (_tmp14_);
				}
				_tmp15_ = plug;
				switchboard_switchboard_app_load_plug (self, _tmp15_);
				_tmp16_ = supported_settings;
				_tmp17_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp16_, setting_path);
				_g_free0 (switchboard_switchboard_app_open_window);
				switchboard_switchboard_app_open_window = (gchar*) _tmp17_;
				result = TRUE;
				_g_object_unref0 (supported_settings);
				_g_object_unref0 (plug);
				_g_object_unref0 (_plug_it);
				return result;
			}
			_g_object_unref0 (supported_settings);
			_g_object_unref0 (plug);
		}
		_g_object_unref0 (_plug_it);
	}
	if (string_contains (setting_path, "/")) {
		gint last_index = 0;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gboolean _tmp20_;
		last_index = string_last_index_of_char (setting_path, (gunichar) '/', 0);
		_tmp18_ = string_substring (setting_path, (glong) 0, (glong) last_index);
		_tmp19_ = _tmp18_;
		_tmp20_ = switchboard_switchboard_app_load_setting_path (self, _tmp19_, plugsmanager);
		_g_free0 (_tmp19_);
		result = _tmp20_;
		return result;
	}
	result = FALSE;
	return result;
}

static void
switchboard_switchboard_app_switch_to_plug (SwitchboardSwitchboardApp* self,
                                            SwitchboardPlug* plug)
{
	gboolean _tmp5_ = FALSE;
	GeeArrayList* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	GtkSearchEntry* _tmp25_;
	GtkStack* _tmp26_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	GtkScrolledWindow* _tmp29_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (plug != NULL);
	if (switchboard_switchboard_app_should_animate_next_transition == FALSE) {
		GtkStack* _tmp0_;
		_tmp0_ = self->priv->stack;
		gtk_stack_set_transition_type (_tmp0_, GTK_STACK_TRANSITION_TYPE_NONE);
		switchboard_switchboard_app_should_animate_next_transition = TRUE;
	} else {
		GtkStack* _tmp1_;
		GtkStackTransitionType _tmp2_;
		GtkStackTransitionType _tmp3_;
		_tmp1_ = self->priv->stack;
		_tmp2_ = gtk_stack_get_transition_type (_tmp1_);
		_tmp3_ = _tmp2_;
		if (_tmp3_ == GTK_STACK_TRANSITION_TYPE_NONE) {
			GtkStack* _tmp4_;
			_tmp4_ = self->priv->stack;
			gtk_stack_set_transition_type (_tmp4_, GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT_RIGHT);
		}
	}
	_tmp6_ = self->previous_plugs;
	_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
	_tmp8_ = _tmp7_;
	if (_tmp8_ > 1) {
		GtkStack* _tmp9_;
		const gchar* _tmp10_;
		_tmp9_ = self->priv->stack;
		_tmp10_ = gtk_stack_get_visible_child_name (_tmp9_);
		_tmp5_ = g_strcmp0 (_tmp10_, "main") != 0;
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		GtkButton* _tmp11_;
		GeeArrayList* _tmp12_;
		gpointer _tmp13_;
		SwitchboardPlug* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
		GeeArrayList* _tmp17_;
		GeeArrayList* _tmp18_;
		gint _tmp19_;
		gint _tmp20_;
		gpointer _tmp21_;
		SwitchboardPlug* _tmp22_;
		_tmp11_ = self->priv->navigation_button;
		_tmp12_ = self->previous_plugs;
		_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) _tmp12_, 0);
		_tmp14_ = (SwitchboardPlug*) _tmp13_;
		_tmp15_ = switchboard_plug_get_display_name (_tmp14_);
		_tmp16_ = _tmp15_;
		gtk_button_set_label (_tmp11_, _tmp16_);
		_g_object_unref0 (_tmp14_);
		_tmp17_ = self->previous_plugs;
		_tmp18_ = self->previous_plugs;
		_tmp19_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp18_);
		_tmp20_ = _tmp19_;
		_tmp21_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp17_, _tmp20_ - 1);
		_tmp22_ = (SwitchboardPlug*) _tmp21_;
		_g_object_unref0 (_tmp22_);
	} else {
		GtkButton* _tmp23_;
		const gchar* _tmp24_;
		_tmp23_ = self->priv->navigation_button;
		_tmp24_ = self->priv->all_settings_label;
		gtk_button_set_label (_tmp23_, _tmp24_);
	}
	_tmp25_ = self->priv->_search_box;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp25_, FALSE);
	switchboard_plug_shown (plug);
	_tmp26_ = self->priv->stack;
	_tmp27_ = switchboard_plug_get_code_name (plug);
	_tmp28_ = _tmp27_;
	gtk_stack_set_visible_child_name (_tmp26_, _tmp28_);
	_tmp29_ = self->priv->category_scrolled;
	gtk_widget_hide ((GtkWidget*) _tmp29_);
}

static gboolean
switchboard_switchboard_app_switch_to_icons (SwitchboardSwitchboardApp* self)
{
	GeeArrayList* _tmp0_;
	GtkScrolledWindow* _tmp1_;
	GtkStack* _tmp2_;
	SwitchboardPlug* _tmp3_;
	GtkHeaderBar* _tmp4_;
	GtkSearchEntry* _tmp5_;
	GtkSearchEntry* _tmp6_;
	SwitchboardPlugsManager* _tmp7_;
	SwitchboardPlugsManager* _tmp8_;
	GtkSearchEntry* _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->previous_plugs;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
	_tmp1_ = self->priv->category_scrolled;
	gtk_widget_show ((GtkWidget*) _tmp1_);
	_tmp2_ = self->priv->stack;
	gtk_stack_set_visible_child_full (_tmp2_, "main", GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT_RIGHT);
	_tmp3_ = self->current_plug;
	switchboard_plug_hidden (_tmp3_);
	_tmp4_ = self->priv->headerbar;
	gtk_header_bar_set_title (_tmp4_, _ ("System Settings"));
	_tmp5_ = self->priv->_search_box;
	gtk_entry_set_text ((GtkEntry*) _tmp5_, "");
	_tmp6_ = self->priv->_search_box;
	_tmp7_ = switchboard_plugs_manager_get_default ();
	_tmp8_ = _tmp7_;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, switchboard_plugs_manager_has_plugs (_tmp8_));
	_g_object_unref0 (_tmp8_);
	_tmp9_ = self->priv->_search_box;
	_tmp10_ = gtk_widget_get_sensitive ((GtkWidget*) _tmp9_);
	_tmp11_ = _tmp10_;
	if (_tmp11_) {
		GtkSearchEntry* _tmp12_;
		_tmp12_ = self->priv->_search_box;
		g_object_set ((GtkWidget*) _tmp12_, "has-focus", TRUE, NULL);
	}
	result = TRUE;
	return result;
}

static gchar*
switchboard_switchboard_app_gcc_to_switchboard_code_name (SwitchboardSwitchboardApp* self,
                                                          const gchar* gcc_name)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
	static GQuark _tmp1_label0 = 0;
	static GQuark _tmp1_label1 = 0;
	static GQuark _tmp1_label2 = 0;
	static GQuark _tmp1_label3 = 0;
	static GQuark _tmp1_label4 = 0;
	static GQuark _tmp1_label5 = 0;
	static GQuark _tmp1_label6 = 0;
	static GQuark _tmp1_label7 = 0;
	static GQuark _tmp1_label8 = 0;
	static GQuark _tmp1_label9 = 0;
	static GQuark _tmp1_label10 = 0;
	static GQuark _tmp1_label11 = 0;
	static GQuark _tmp1_label12 = 0;
	static GQuark _tmp1_label13 = 0;
	static GQuark _tmp1_label14 = 0;
	static GQuark _tmp1_label15 = 0;
	static GQuark _tmp1_label16 = 0;
	static GQuark _tmp1_label17 = 0;
	static GQuark _tmp1_label18 = 0;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (gcc_name != NULL, NULL);
	_tmp0_ = gcc_name;
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("background")))) {
		switch (0) {
			default:
			{
				gchar* _tmp3_;
				_tmp3_ = g_strdup ("pantheon-desktop");
				result = _tmp3_;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("bluetooth")))) {
		switch (0) {
			default:
			{
				gchar* _tmp4_;
				_tmp4_ = g_strdup ("network-pantheon-bluetooth");
				result = _tmp4_;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("color")))) {
		switch (0) {
			default:
			{
				gchar* _tmp5_;
				_tmp5_ = g_strdup ("hardware-gcc-color");
				result = _tmp5_;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("datetime")))) {
		switch (0) {
			default:
			{
				gchar* _tmp6_;
				_tmp6_ = g_strdup ("system-pantheon-datetime");
				result = _tmp6_;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("display")))) {
		switch (0) {
			default:
			{
				gchar* _tmp7_;
				_tmp7_ = g_strdup ("system-pantheon-display");
				result = _tmp7_;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label5) ? _tmp1_label5 : (_tmp1_label5 = g_quark_from_static_string ("info")))) {
		switch (0) {
			default:
			{
				gchar* _tmp8_;
				_tmp8_ = g_strdup ("system-pantheon-about");
				result = _tmp8_;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label6) ? _tmp1_label6 : (_tmp1_label6 = g_quark_from_static_string ("keyboard")))) {
		switch (0) {
			default:
			{
				gchar* _tmp9_;
				_tmp9_ = g_strdup ("hardware-pantheon-keyboard");
				result = _tmp9_;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label7) ? _tmp1_label7 : (_tmp1_label7 = g_quark_from_static_string ("network")))) {
		switch (0) {
			default:
			{
				gchar* _tmp10_;
				_tmp10_ = g_strdup ("pantheon-network");
				result = _tmp10_;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label8) ? _tmp1_label8 : (_tmp1_label8 = g_quark_from_static_string ("power")))) {
		switch (0) {
			default:
			{
				gchar* _tmp11_;
				_tmp11_ = g_strdup ("system-pantheon-power");
				result = _tmp11_;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label9) ? _tmp1_label9 : (_tmp1_label9 = g_quark_from_static_string ("printers")))) {
		switch (0) {
			default:
			{
				gchar* _tmp12_;
				_tmp12_ = g_strdup ("pantheon-printers");
				result = _tmp12_;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label10) ? _tmp1_label10 : (_tmp1_label10 = g_quark_from_static_string ("privacy")))) {
		switch (0) {
			default:
			{
				gchar* _tmp13_;
				_tmp13_ = g_strdup ("pantheon-security-privacy");
				result = _tmp13_;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label11) ? _tmp1_label11 : (_tmp1_label11 = g_quark_from_static_string ("region")))) {
		switch (0) {
			default:
			{
				gchar* _tmp14_;
				_tmp14_ = g_strdup ("system-pantheon-locale");
				result = _tmp14_;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label12) ? _tmp1_label12 : (_tmp1_label12 = g_quark_from_static_string ("sharing")))) {
		switch (0) {
			default:
			{
				gchar* _tmp15_;
				_tmp15_ = g_strdup ("pantheon-sharing");
				result = _tmp15_;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label13) ? _tmp1_label13 : (_tmp1_label13 = g_quark_from_static_string ("sound")))) {
		switch (0) {
			default:
			{
				gchar* _tmp16_;
				_tmp16_ = g_strdup ("hardware-gcc-sound");
				result = _tmp16_;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label14) ? _tmp1_label14 : (_tmp1_label14 = g_quark_from_static_string ("universal-access")))) {
		switch (0) {
			default:
			{
				gchar* _tmp17_;
				_tmp17_ = g_strdup ("pantheon-accessibility");
				result = _tmp17_;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label15) ? _tmp1_label15 : (_tmp1_label15 = g_quark_from_static_string ("user-accounts")))) {
		switch (0) {
			default:
			{
				gchar* _tmp18_;
				_tmp18_ = g_strdup ("system-pantheon-useraccounts");
				result = _tmp18_;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label16) ? _tmp1_label16 : (_tmp1_label16 = g_quark_from_static_string ("wacom")))) {
		switch (0) {
			default:
			{
				gchar* _tmp19_;
				_tmp19_ = g_strdup ("hardware-gcc-wacom");
				result = _tmp19_;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label17) ? _tmp1_label17 : (_tmp1_label17 = g_quark_from_static_string ("notifications")))) {
		switch (0) {
			default:
			{
				gchar* _tmp20_;
				_tmp20_ = g_strdup ("personal-pantheon-notifications");
				result = _tmp20_;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label18) ? _tmp1_label18 : (_tmp1_label18 = g_quark_from_static_string ("search")))) {
		switch (0) {
			default:
			{
				result = NULL;
				return result;
			}
		}
	}
	result = NULL;
	return result;
}

SwitchboardSwitchboardApp*
switchboard_switchboard_app_construct (GType object_type)
{
	SwitchboardSwitchboardApp * self = NULL;
	self = (SwitchboardSwitchboardApp*) g_object_new (object_type, NULL);
	return self;
}

SwitchboardSwitchboardApp*
switchboard_switchboard_app_new (void)
{
	return switchboard_switchboard_app_construct (SWITCHBOARD_TYPE_SWITCHBOARD_APP);
}

GtkSearchEntry*
switchboard_switchboard_app_get_search_box (SwitchboardSwitchboardApp* self)
{
	GtkSearchEntry* result;
	GtkSearchEntry* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_search_box;
	result = _tmp0_;
	return result;
}

static void
switchboard_switchboard_app_set_search_box (SwitchboardSwitchboardApp* self,
                                            GtkSearchEntry* value)
{
	GtkSearchEntry* old_value;
	g_return_if_fail (self != NULL);
	old_value = switchboard_switchboard_app_get_search_box (self);
	if (old_value != value) {
		GtkSearchEntry* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_search_box);
		self->priv->_search_box = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, switchboard_switchboard_app_properties[SWITCHBOARD_SWITCHBOARD_APP_SEARCH_BOX_PROPERTY]);
	}
}

SwitchboardSwitchboardApp*
switchboard_switchboard_app_get_instance (void)
{
	SwitchboardSwitchboardApp* result;
	SwitchboardSwitchboardApp* _tmp0_;
	SwitchboardSwitchboardApp* _tmp2_;
	_tmp0_ = switchboard_switchboard_app__instance;
	if (_tmp0_ == NULL) {
		SwitchboardSwitchboardApp* _tmp1_;
		_tmp1_ = switchboard_switchboard_app_new ();
		_g_object_unref0 (switchboard_switchboard_app__instance);
		switchboard_switchboard_app__instance = _tmp1_;
	}
	_tmp2_ = switchboard_switchboard_app__instance;
	result = _tmp2_;
	return result;
}

static GObject *
switchboard_switchboard_app_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SwitchboardSwitchboardApp * self;
	GApplicationFlags _tmp0_;
	GApplicationFlags _tmp1_;
	GAppInfo* _tmp2_;
	GAppInfo* _tmp3_;
	gboolean _tmp4_;
	GError* _inner_error0_ = NULL;
	parent_class = G_OBJECT_CLASS (switchboard_switchboard_app_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SWITCHBOARD_TYPE_SWITCHBOARD_APP, SwitchboardSwitchboardApp);
	g_application_set_application_id ((GApplication*) self, "io.elementary.switchboard");
	_tmp0_ = g_application_get_flags ((GApplication*) self);
	_tmp1_ = _tmp0_;
	g_application_set_flags ((GApplication*) self, _tmp1_ | G_APPLICATION_HANDLES_OPEN);
	_tmp2_ = g_app_info_get_default_for_uri_scheme ("settings");
	_tmp3_ = _tmp2_;
	_tmp4_ = _tmp3_ == NULL;
	_g_object_unref0 (_tmp3_);
	if (_tmp4_) {
		GDesktopAppInfo* appinfo = NULL;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GDesktopAppInfo* _tmp9_;
		GDesktopAppInfo* _tmp10_;
		_tmp5_ = g_application_get_application_id ((GApplication*) self);
		_tmp6_ = _tmp5_;
		_tmp7_ = g_strconcat (_tmp6_, ".desktop", NULL);
		_tmp8_ = _tmp7_;
		_tmp9_ = g_desktop_app_info_new (_tmp8_);
		_tmp10_ = _tmp9_;
		_g_free0 (_tmp8_);
		appinfo = _tmp10_;
		{
			GDesktopAppInfo* _tmp11_;
			_tmp11_ = appinfo;
			g_app_info_set_as_default_for_type ((GAppInfo*) _tmp11_, "x-scheme-handler/settings", &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp12_;
			const gchar* _tmp13_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp12_ = e;
			_tmp13_ = _tmp12_->message;
			g_critical ("Switchboard.vala:77: Unable to set default for the settings scheme: %s", _tmp13_);
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (appinfo);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
		}
		_g_object_unref0 (appinfo);
	}
	return obj;
}

static void
switchboard_switchboard_app_class_init (SwitchboardSwitchboardAppClass * klass,
                                        gpointer klass_data)
{
	switchboard_switchboard_app_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SwitchboardSwitchboardApp_private_offset);
	((GApplicationClass *) klass)->open = (void (*) (GApplication*, GFile**, gint, const gchar*)) switchboard_switchboard_app_real_open;
	((GApplicationClass *) klass)->activate = (void (*) (GApplication*)) switchboard_switchboard_app_real_activate;
	G_OBJECT_CLASS (klass)->get_property = _vala_switchboard_switchboard_app_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_switchboard_switchboard_app_set_property;
	G_OBJECT_CLASS (klass)->constructor = switchboard_switchboard_app_constructor;
	G_OBJECT_CLASS (klass)->finalize = switchboard_switchboard_app_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SWITCHBOARD_SWITCHBOARD_APP_SEARCH_BOX_PROPERTY, switchboard_switchboard_app_properties[SWITCHBOARD_SWITCHBOARD_APP_SEARCH_BOX_PROPERTY] = g_param_spec_object ("search-box", "search-box", "search-box", gtk_search_entry_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
switchboard_switchboard_app_instance_init (SwitchboardSwitchboardApp * self,
                                           gpointer klass)
{
	gchar* _tmp0_;
	self->priv = switchboard_switchboard_app_get_instance_private (self);
	_tmp0_ = g_strdup (_ ("All Settings"));
	self->priv->all_settings_label = _tmp0_;
}

static void
switchboard_switchboard_app_finalize (GObject * obj)
{
	SwitchboardSwitchboardApp * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SWITCHBOARD_TYPE_SWITCHBOARD_APP, SwitchboardSwitchboardApp);
	_g_object_unref0 (self->priv->main_window);
	_g_object_unref0 (self->priv->category_scrolled);
	_g_object_unref0 (self->priv->stack);
	_g_object_unref0 (self->priv->headerbar);
	_g_object_unref0 (self->priv->alert_view);
	_g_object_unref0 (self->priv->navigation_button);
	_g_object_unref0 (self->category_view);
	_g_object_unref0 (self->priv->loaded_plugs);
	_g_free0 (self->priv->all_settings_label);
	_g_object_unref0 (self->previous_plugs);
	_g_object_unref0 (self->current_plug);
	_g_object_unref0 (self->priv->_search_box);
	G_OBJECT_CLASS (switchboard_switchboard_app_parent_class)->finalize (obj);
}

static GType
switchboard_switchboard_app_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SwitchboardSwitchboardAppClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) switchboard_switchboard_app_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SwitchboardSwitchboardApp), 0, (GInstanceInitFunc) switchboard_switchboard_app_instance_init, NULL };
	GType switchboard_switchboard_app_type_id;
	switchboard_switchboard_app_type_id = g_type_register_static (gtk_application_get_type (), "SwitchboardSwitchboardApp", &g_define_type_info, 0);
	SwitchboardSwitchboardApp_private_offset = g_type_add_instance_private (switchboard_switchboard_app_type_id, sizeof (SwitchboardSwitchboardAppPrivate));
	return switchboard_switchboard_app_type_id;
}

GType
switchboard_switchboard_app_get_type (void)
{
	static volatile gsize switchboard_switchboard_app_type_id__volatile = 0;
	if (g_once_init_enter (&switchboard_switchboard_app_type_id__volatile)) {
		GType switchboard_switchboard_app_type_id;
		switchboard_switchboard_app_type_id = switchboard_switchboard_app_get_type_once ();
		g_once_init_leave (&switchboard_switchboard_app_type_id__volatile, switchboard_switchboard_app_type_id);
	}
	return switchboard_switchboard_app_type_id__volatile;
}

static void
_vala_switchboard_switchboard_app_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	SwitchboardSwitchboardApp * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SWITCHBOARD_TYPE_SWITCHBOARD_APP, SwitchboardSwitchboardApp);
	switch (property_id) {
		case SWITCHBOARD_SWITCHBOARD_APP_SEARCH_BOX_PROPERTY:
		g_value_set_object (value, switchboard_switchboard_app_get_search_box (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_switchboard_switchboard_app_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	SwitchboardSwitchboardApp * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SWITCHBOARD_TYPE_SWITCHBOARD_APP, SwitchboardSwitchboardApp);
	switch (property_id) {
		case SWITCHBOARD_SWITCHBOARD_APP_SEARCH_BOX_PROPERTY:
		switchboard_switchboard_app_set_search_box (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

